module.exports =
/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 1);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
var ClaraConstants = {
  // Types
  POLYMESH: 'PolyMesh',
  NULL: 'Null',
  CAMERA: 'Camera',
  MATERIAL: 'Material',
  MODEL: 'Model',
  IMAGE: 'Image',
  ANNOTATION: 'Annotation',

  // Properties
  REFERENCE: 'reference',
  VISIBLE: 'visible',
  BASE_COLOR: 'baseColor',
  BASE_MAP: 'baseMap',
  TRANSLATION: 'translation',
  ROTATION: 'rotation',
  SCALE: 'scale',
  BINARY: 'binary',

  // Plugs
  TRANSFORM: 'Transform',
  PHYSICAL: 'Physical',

  toolbar: {
    HOME: 'home',
    PAN: 'pan',
    ORBIT: 'orbit',
    ZOOM: 'zoom',
    VR: 'vrSettings',
    FULLSCREEN: 'fullscreen'
  }
};

exports.default = ClaraConstants;

/***/ }),
/* 1 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ClaraConstants = exports.ClaraFacade = exports.default = undefined;

var _claraFacade = __webpack_require__(2);

var _claraFacade2 = _interopRequireDefault(_claraFacade);

var _claraConstants = __webpack_require__(0);

var _claraConstants2 = _interopRequireDefault(_claraConstants);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = _claraFacade2.default;
exports.ClaraFacade = _claraFacade2.default;
exports.ClaraConstants = _claraConstants2.default;

/***/ }),
/* 2 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _claraScene = __webpack_require__(3);

var _claraScene2 = _interopRequireDefault(_claraScene);

var _claraAnimation = __webpack_require__(4);

var _claraAnimation2 = _interopRequireDefault(_claraAnimation);

var _claraEvents = __webpack_require__(5);

var _claraEvents2 = _interopRequireDefault(_claraEvents);

var _colorHelper = __webpack_require__(8);

var _colorHelper2 = _interopRequireDefault(_colorHelper);

var _claraConstants = __webpack_require__(0);

var _claraConstants2 = _interopRequireDefault(_claraConstants);

var _claraSnapshot = __webpack_require__(9);

var _claraSnapshot2 = _interopRequireDefault(_claraSnapshot);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var ClaraFacade = function ClaraFacade() {
  var _this = this;

  _classCallCheck(this, ClaraFacade);

  this.sceneContainerId = null;
  this.claraApi = null;
  this.events = null;
  this.scene = null;
  this.animation = null;
  this.snapshot = null;
  this.lookAtNodeId = null;
  this.outOfFocusMaterialId = null;
  this.initialMeshMaterials = null;

  this.initializeScene = function (sceneContainerId) {
    _this.sceneContainerId = sceneContainerId;
    _this.claraApi = claraplayer(_this.sceneContainerId); // eslint-disable-line no-undef
    _this.claraApi.player.displayThumbnail(false);
    _this.claraApi.selection.setHighlighting(true);
    _this.claraApi.commands.updateCommand('select', { enabled: false });

    _this.events = new _claraEvents2.default(_this.claraApi, _this.sceneContainerId);
    _this.scene = new _claraScene2.default(_this.claraApi);
    _this.animation = new _claraAnimation2.default(_this.claraApi);
    _this.snapshot = new _claraSnapshot2.default(_this.claraApi);

    _this._registerEvents();
  };

  this._registerEvents = function () {
    _this.events.registerOnPreloaded(_this._onClaraScenePreloaded);
    _this.events.registerOnRendered(_this._onClaraSceneRendered);
    _this.events.registerOnHomeButtonPressed(_this.animation.resetAllAnimations);
  };

  this._onClaraScenePreloaded = function () {
    var baseColor = { r: 1, g: 0.5, b: 0.5 };
    _this.outOfFocusMaterialId = _this.scene.createMaterial('_Out_of_focus_MAT_', { opacityFactor: 0.5, baseColor: baseColor });
    var meshMaterialsReference = {
      type: _claraConstants2.default.POLYMESH,
      plug: _claraConstants2.default.MATERIAL,
      property: _claraConstants2.default.REFERENCE
    };
    _this.initialMeshMaterials = _this.claraApi.scene.getAll(meshMaterialsReference);
  };

  this._onClaraSceneRendered = function () {
    var root = _this.scene.findRootModelOrNull();
    var lookAtNode = _this.claraApi.scene.addNode({
      name: 'LOOK_AT_NODE',
      type: _claraConstants2.default.NULL,
      parent: root
    });
    _this.lookAtNodeId = _this.scene.getId(lookAtNode);
  };

  this.renderScene = function (claraSceneId) {
    _this.claraApi.sceneIO.fetchAndUse(claraSceneId, null, { waitForPublish: true });
  };

  this.renderPublishedScene = function (claraSceneId, hash) {
    _this.claraApi.sceneIO.fetchAndUse(claraSceneId, hash);
  };

  this.animateToMainCamera = function () {
    var mainCameraId = _this.claraApi.scene.find({ type: _claraConstants2.default.CAMERA, name: _claraConstants2.default.CAMERA });
    var mainCameraTransform = _this.scene.getTransform(mainCameraId);
    var easingTranslation = {
      x: mainCameraTransform.position.z * -2,
      y: mainCameraTransform.position.y,
      z: mainCameraTransform.position.x
    };
    var root = _this.claraApi.scene.find({ name: 'Objects' });
    var easingTarget = _this.scene.getId(_this.claraApi.scene.addNode({ name: 'easingTarget', type: _claraConstants2.default.NULL, parent: root }));
    var easingCameraId = _this.scene.getId(_this.claraApi.scene.addNode({
      name: 'easingCamera',
      type: _claraConstants2.default.CAMERA,
      parent: root,
      plugs: {
        Transform: [[_claraConstants2.default.TRANSFORM, {
          translation: easingTranslation
        }], ['LookAt', { target: easingTarget }]]
      }
    }));
    _this.claraApi.player.useCamera(easingCameraId);
    return _this.claraApi.player.animateCameraTo(mainCameraId, 2000);
  };

  this.disableTools = function (tools) {
    tools.forEach(function (tool) {
      return _this.disableTool(tool);
    });
  };

  this.hideTools = function (tools) {
    tools.forEach(function (tool) {
      return _this.hideTool(tool);
    });
  };

  this.disableTool = function (tool) {
    _this.claraApi.player.removeTool(tool);
  };

  this.hideTool = function (tool) {
    _this.claraApi.player.hideTool(tool);
  };

  this.hideToolbar = function () {
    Object.values(_claraConstants2.default.toolbar).forEach(function (tool) {
      return _this.hideTool(tool);
    });
  };

  this.enableHelpTool = function (onShowHelp) {
    _this.claraApi.commands.addCommand({
      options: { icon: 'help' },
      display: { playerTools: true },
      label: 'help',
      execute: function execute() {
        _this.claraApi.player.exitFullscreen();
        onShowHelp();
      }
    });
  };

  this.setActiveColor = function (rgbColor) {
    _this.claraApi.player.setActiveColor(rgbColor);
  };

  this.setHoverColor = function (rgbColor) {
    _this.claraApi.player.setHoverColor(rgbColor);
  };

  this.showMesh = function (name) {
    var nodeId = _this.scene.findMeshOrNullByName(name);

    if (!nodeId) {
      console.error('Cannot find node named: ' + name);
      return;
    }

    _this.hideAllSiblingMeshes(nodeId);
  };

  this.hideMesh = function (name) {
    var nodeId = _this.scene.findMeshOrNullByName(name);
    _this.setVisibilityRecursively(nodeId, false);
  };

  this.hideAllSiblingMeshes = function (nodeId) {
    var parentId = _this.scene.findParent(nodeId);

    var siblings = _this.claraApi.scene.filter({
      from: { id: parentId },
      shallow: true
    });

    siblings.forEach(function (siblingId) {
      _this.setVisibilityRecursively(siblingId, false);
    });
    _this.setVisibilityRecursively(nodeId, true);
  };

  this.spawnAnnotation = function (childName, name) {
    var childId = _this.scene.findMeshOrNullByName(childName);

    if (!childId) {
      console.error('Could not find node with name "' + childName + '" in order to place a hotspot!');
      return null;
    }

    var annotation = _this.claraApi.sceneGraph.addNode({
      name: name,
      type: _claraConstants2.default.ANNOTATION,
      parent: childId,
      plugs: {
        Annotation: [[_claraConstants2.default.ANNOTATION, {
          limitVisilibility: true,
          directionMode: 'awayFromOrigin',
          directionTarget: _this.claraApi.scene.find({ type: _claraConstants2.default.MODEL })
        }]],
        Transform: [[_claraConstants2.default.TRANSFORM, {}]],
        Properties: [['Default', {}]]
      }
    });
    return _this.scene.getId(annotation);
  };

  this.setVisibilityRecursively = function (nodeId, isVisible) {
    _this.claraApi.scene.setAll({
      from: { id: nodeId },
      plug: 'Properties',
      property: _claraConstants2.default.VISIBLE,
      includeParent: true
    }, isVisible);
  };

  this.overrideClaraAnnotations = function (updateFunctionToCall) {
    _this.claraApi.annotations.useCustomAnnotationFunction(updateFunctionToCall);
  };

  this.changeColor = function (materialName, r, g, b) {
    var materialId = _this.scene.findMaterial(materialName);
    if (!materialId) {
      console.error('Cannot find material named: ' + materialName);
      return;
    }

    var baseColor = _this.claraApi.scene.find({
      id: materialId,
      plug: _claraConstants2.default.MATERIAL,
      property: _claraConstants2.default.BASE_COLOR
    });
    _this.claraApi.scene.set(baseColor, _this.createColorObjectForClara(r, g, b));
  };

  this.changeBaseTexture = function (materialName, textureName) {
    var materialId = _this.scene.findMaterial(materialName);
    if (!materialId) {
      console.error('Cannot find material named: ' + materialName);
      return;
    }

    var textureId = _this.scene.findTexture(textureName);
    if (!textureId) {
      console.error('Cannot find texture named: ' + textureName);
      return;
    }

    var materialBaseMap = { id: materialId, plug: _claraConstants2.default.MATERIAL, property: _claraConstants2.default.BASE_MAP };
    _this.claraApi.scene.set(materialBaseMap, textureId);
  };

  this.createColorObjectForClara = function (r, g, b) {
    return _colorHelper2.default.convertColorGammaToLinear(_colorHelper2.default.createColorObject0to1(r, g, b));
  };

  this.convertPositionOffsetUnityToClara = function (offset) {
    var result = _extends({}, offset);
    result.x *= -100;
    result.y *= 100;
    result.z *= 100;
    return result;
  };

  this.swapMaterialByMeshName = function (meshName, materialName) {
    var meshNodeId = _this.claraApi.scene.find({ type: _claraConstants2.default.POLYMESH, name: meshName });
    if (!meshNodeId) {
      console.error('Could not find a mesh with name "' + meshName + '" in order to swap the material.');
      return;
    }

    var materialId = _this.scene.findMaterial(materialName);
    if (!materialId) {
      console.error('Could not find material with name "' + materialName + '\' in order to swap the material.');
      return;
    }
    _this.scene.setMaterial(meshNodeId, materialId);
  };

  this.rotateAroundWorldAxis = function (nodeId, rotation) {
    var THREE = _this.claraApi.deps.THREE;
    var oldParentId = _this.scene.findParent(nodeId);
    var nodeTransform = _this.claraApi.scene.getWorldTransform(nodeId);

    var eulerRotation = new THREE.Euler(rotation.x, rotation.y, rotation.z, 'ZYX');
    var newTransformMatrix = new THREE.Matrix4().makeRotationFromEuler(eulerRotation).multiply(nodeTransform);
    var parentTransform = _this.claraApi.scene.getWorldTransform(oldParentId);

    var newRelativeTransform = void 0;
    if (parentTransform) {
      var parentWorldInverse = new THREE.Matrix4().getInverse(_this.claraApi.scene.getWorldTransform(oldParentId));
      newRelativeTransform = new THREE.Matrix4().multiplyMatrices(parentWorldInverse, newTransformMatrix);
    } else {
      newRelativeTransform = newTransformMatrix;
    }

    var newNodeTranslate = new THREE.Vector3();
    var newNodeRotate = new THREE.Quaternion();
    var newNodeScale = new THREE.Vector3();
    newRelativeTransform.decompose(newNodeTranslate, newNodeRotate, newNodeScale);
    var rotateVec = new THREE.Euler().setFromQuaternion(newNodeRotate, 'ZYX').toVector3().multiplyScalar(180.0 / Math.PI);

    _this.scene.setTransform(nodeId, newNodeTranslate, rotateVec, newNodeScale);
  };

  this.swapMaterials = function (oldMaterialName, newMaterialName) {
    var newMaterialId = _this.scene.findMaterial(newMaterialName);
    if (!newMaterialId) {
      console.error('Could not find material with name "' + newMaterialName + '" to swap');
      return;
    }

    var materialPaths = _this.scene.findMeshesWithMaterialByName(oldMaterialName);
    if (materialPaths.length === 0) {
      console.error('Found no meshes that use material "' + oldMaterialName + '" to swap');
      return;
    }

    _this.claraApi.scene.setAll(materialPaths, newMaterialId);
  };

  this.addExecuteToolbarButton = function (iconName, onClickedCallback) {
    return _this.claraApi.commands.addCommand({
      options: { icon: iconName },
      display: { playerTools: true },
      execute: onClickedCallback
    });
  };

  this.addToggleToolbarButton = function (iconName, onActivateCallback, onDeactivateCallback) {
    return _this.claraApi.commands.addCommand({
      options: { icon: iconName },
      display: { playerTools: true },
      activate: onActivateCallback,
      deactivate: onDeactivateCallback
    });
  };

  this.flyTo = function (nodeName, zoomLevel) {
    var nodeId = _this.scene.findMeshOrNullByName(nodeName);
    if (nodeId) {
      var zoomLevelValue = !zoomLevel ? _this.getAutoCalculatedZoomLevel(nodeId) : zoomLevel;
      _this.claraApi.selection.selectNode(nodeId);
      var nodeCenter = _this.getCenter(nodeId);
      var lookAtCameraId = _this.createSecondaryLookAtCamera(nodeCenter, zoomLevelValue);
      _this.claraApi.player.animateCameraTo(lookAtCameraId, 2000).then(function () {
        _this.claraApi.sceneGraph.deleteNode(lookAtCameraId);
      });
    } else {
      console.error('Could not find node with name "' + nodeName + '" to fly to.');
    }
  };

  this.focusOn = function (nodeName, zoomLevel) {
    _this.unfocusAll();
    _this.flyTo(nodeName, zoomLevel);
    var nodeId = _this.scene.findMeshOrNullByName(nodeName);
    if (!nodeId) {
      console.error('Could not find node with name "' + nodeName + '" to focus on.');
      return;
    }
    _this.claraApi.selection.selectNode(nodeId);
    var meshMaterialReferencePaths = _this.claraApi.scene.filter({
      type: _claraConstants2.default.POLYMESH,
      plug: _claraConstants2.default.MATERIAL,
      property: _claraConstants2.default.REFERENCE
    });
    var focusedNodes = _this.claraApi.scene.filter({
      from: { id: nodeId },
      includeParent: true
    });
    var contextNodes = _this.claraApi.scene.filter({
      from: { name: 'Context' },
      type: _claraConstants2.default.POLYMESH,
      includeParent: true
    });
    var nonSelectedMeshes = meshMaterialReferencePaths.filter(function (path) {
      return !focusedNodes.includes(path[0]) && !contextNodes.includes(path[0]);
    });
    // Apply the newly created material to all unfocused meshes.
    _this.claraApi.scene.setAll(nonSelectedMeshes, _this.outOfFocusMaterialId);
  };

  this.unfocusAll = function () {
    Object.keys(_this.initialMeshMaterials).forEach(function (meshId) {
      _this.scene.setMaterial(meshId, _this.initialMeshMaterials[meshId]);
    });
    _this.claraApi.selection.deselectAll();
  };

  this.getAutoCalculatedZoomLevel = function (nodeId) {
    var boundingLength = _this.getAverageBoundingBoxLength(nodeId);
    return 0.0995359 + 2.906155 * boundingLength + -0.7061069 * boundingLength * boundingLength;
  };

  this.getAverageBoundingBoxLength = function (nodeId) {
    var boundingBox = _this.claraApi.scene.getNodeBoundingBox(nodeId);
    var lengthX = boundingBox.max.x - boundingBox.min.x;
    var lengthY = boundingBox.max.y - boundingBox.min.y;
    var lengthZ = boundingBox.max.z - boundingBox.min.z;
    return (lengthX + lengthY + lengthZ) / 3;
  };

  this.getCenter = function (nodeId) {
    var THREE = _this.claraApi.deps.THREE;
    var boundingBox = _this.claraApi.scene.getNodeBoundingBox(nodeId);
    var center = new THREE.Vector3();
    center.x = (boundingBox.min.x + boundingBox.max.x) / 2;
    center.y = (boundingBox.min.y + boundingBox.max.y) / 2;
    center.z = (boundingBox.min.z + boundingBox.max.z) / 2;
    return center;
  };

  this.createSecondaryLookAtCamera = function (partCenter, zoomLevel) {
    var root = _this.scene.findRootModelOrNull();
    var lookAtNodeTranslation = {
      id: _this.lookAtNodeId,
      plug: _claraConstants2.default.TRANSFORM,
      property: _claraConstants2.default.TRANSLATION
    };
    _this.claraApi.scene.set(lookAtNodeTranslation, partCenter);

    var partTranslationInWorld = _this.getTranslationInWorld(_this.lookAtNodeId);
    var originToPartVectorNormalized = partTranslationInWorld.clone().normalize();
    var cameraVector = originToPartVectorNormalized.multiplyScalar(zoomLevel);
    var cameraPosition = partTranslationInWorld.add(cameraVector);

    var camera = _this.claraApi.scene.addNode({
      name: 'secondaryCamera',
      type: _claraConstants2.default.CAMERA,
      parent: root,
      plugs: {
        Transform: [[_claraConstants2.default.TRANSFORM, {
          translation: cameraPosition
        }], ['LookAt', {
          target: _this.lookAtNodeId
        }]],
        Camera: [[_claraConstants2.default.CAMERA, {
          nearClip: 0.01
        }]]
      }
    });
    return _this.scene.getId(camera);
  };

  this.getTranslationInWorld = function (nodeId) {
    var THREE = _this.claraApi.deps.THREE;
    var partTransformMatrix = _this.claraApi.scene.getWorldTransform(nodeId);
    var translation = new THREE.Vector3();
    translation.setFromMatrixPosition(partTransformMatrix);
    return translation;
  };

  this.setMeshQuality = function () {
    var level = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;

    var meshQualityPaths = _this.claraApi.scene.filter({ type: _claraConstants2.default.POLYMESH, plug: _claraConstants2.default.POLYMESH, property: 'level' + level });
    var meshIdsToQualityIds = _this.claraApi.scene.getAll(meshQualityPaths);
    Object.entries(meshIdsToQualityIds).forEach(function (_ref) {
      var _ref2 = _slicedToArray(_ref, 2),
          meshId = _ref2[0],
          qualityLevelId = _ref2[1];

      var meshBinary = { id: meshId, plug: _claraConstants2.default.POLYMESH, property: _claraConstants2.default.BINARY };
      _this.claraApi.scene.set(meshBinary, qualityLevelId);
    });
  };

  this.getMeshQuality = function () {
    var meshId = _this.claraApi.scene.find({ type: 'PolyMesh' });
    var currentQualityLevelId = _this.claraApi.scene.get({ id: meshId, plug: 'PolyMesh', property: 'binary' });
    for (var level = 0; level <= 4; level += 1) {
      var qualityLevelId = _this.claraApi.scene.get({ id: meshId, plug: 'PolyMesh', property: 'level' + level });
      if (qualityLevelId === currentQualityLevelId) {
        return level;
      }
    }
    return -1;
  };
};

exports.default = ClaraFacade;

/***/ }),
/* 3 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _claraConstants = __webpack_require__(0);

var _claraConstants2 = _interopRequireDefault(_claraConstants);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var ClaraScene = function ClaraScene(claraApi) {
  var _this = this;

  _classCallCheck(this, ClaraScene);

  this.findParent = function (nodeId) {
    return _this.claraApi.scene.find({
      id: nodeId,
      parent: true
    });
  };

  this.findRootModelOrNull = function () {
    var rootNodeId = _this.findFirstLevelNodeInScene(_claraConstants2.default.MODEL);

    if (!rootNodeId) {
      rootNodeId = _this.findFirstLevelNodeInScene(_claraConstants2.default.NULL);
    }

    return rootNodeId;
  };

  this.findFirstLevelNodeInScene = function (type) {
    return _this.claraApi.scene.find({ from: { name: 'Objects' }, shallow: true, type: type });
  };

  this.findMeshOrNullByName = function (name) {
    return _this.findByNameAndTypes([_claraConstants2.default.POLYMESH, _claraConstants2.default.NULL, _claraConstants2.default.MODEL], name);
  };

  this.findByNameAndTypes = function (types, name) {
    return _this.claraApi.scene.find({ type: types, name: name });
  };

  this.findMeshesWithMaterialByName = function (materialName) {
    var materialPaths = [];
    var meshIds = _this.claraApi.scene.filter({ type: _claraConstants2.default.POLYMESH });
    meshIds.forEach(function (meshId) {
      var materialRef = _this.getMaterialReference(meshId);
      if (materialRef !== null) {
        var existingMaterial = _this.claraApi.scene.get({ id: materialRef, property: 'name' });
        if (existingMaterial === materialName) {
          materialPaths.push(_this.findMaterialReference(meshId));
        }
      }
    });
    return materialPaths;
  };

  this.findMaterialReference = function (meshId) {
    return _this.claraApi.scene.find({ id: meshId, plug: _claraConstants2.default.MATERIAL, property: _claraConstants2.default.REFERENCE });
  };

  this.findMaterial = function (name) {
    return _this.findByNameAndTypes(_claraConstants2.default.MATERIAL, name);
  };

  this.findTexture = function (name) {
    return _this.findByNameAndTypes(_claraConstants2.default.IMAGE, name);
  };

  this.getId = function (node) {
    return node._result; // eslint-disable-line no-underscore-dangle
  };

  this.getCameraTransform = function () {
    var cameraId = _this.claraApi.player.getCamera();
    return _this.getTransform(cameraId);
  };

  this.setTransform = function (nodeId, position, rotation, scale) {
    _this.setPosition(nodeId, position);
    _this.setRotation(nodeId, rotation);
    _this.setScale(nodeId, scale);
  };

  this.setPosition = function (nodeId, position) {
    _this.setTransformProperty(nodeId, position, _claraConstants2.default.TRANSLATION);
  };

  this.setRotation = function (nodeId, rotation) {
    _this.setTransformProperty(nodeId, rotation, _claraConstants2.default.ROTATION);
  };

  this.setScale = function (nodeId, scale) {
    _this.setTransformProperty(nodeId, scale, _claraConstants2.default.SCALE);
  };

  this.setTransformProperty = function (nodeId, value, propertyName) {
    _this.claraApi.scene.set({
      id: nodeId,
      plug: _claraConstants2.default.TRANSFORM,
      property: propertyName
    }, value);
  };

  this.getTransform = function (nodeId) {
    var position = _this.getPosition(nodeId);
    var rotation = _this.getRotation(nodeId);
    return { position: position, rotation: rotation };
  };

  this.getPosition = function (nodeId) {
    return _this.getTransformProperty(nodeId, _claraConstants2.default.TRANSLATION);
  };

  this.getRotation = function (nodeId) {
    return _this.getTransformProperty(nodeId, _claraConstants2.default.ROTATION);
  };

  this.getScale = function (nodeId) {
    return _this.getTransformProperty(nodeId, _claraConstants2.default.SCALE);
  };

  this.getTransformProperty = function (nodeId, propertyName) {
    return _this.claraApi.scene.get({
      id: nodeId,
      plug: _claraConstants2.default.TRANSFORM,
      property: propertyName
    });
  };

  this.getMaterialReference = function (meshId) {
    return _this.claraApi.scene.get({ id: meshId, plug: _claraConstants2.default.MATERIAL, property: _claraConstants2.default.REFERENCE });
  };

  this.setMaterial = function (meshId, materialId) {
    var meshReference = { id: meshId, plug: _claraConstants2.default.MATERIAL, property: _claraConstants2.default.REFERENCE };
    _this.claraApi.scene.set(meshReference, materialId);
  };

  this.createMaterial = function (name, properties) {
    var materialLibrary = _this.claraApi.scene.find('%MaterialLibrary');
    var plugs = {
      Material: [[_claraConstants2.default.PHYSICAL, properties]]
    };
    return _this.getId(_this.claraApi.scene.addNode({
      name: name,
      type: _claraConstants2.default.MATERIAL,
      parent: materialLibrary,
      plugs: plugs
    }));
  };

  this.claraApi = claraApi;
};

exports.default = ClaraScene;

/***/ }),
/* 4 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var ClaraAnimation = function ClaraAnimation(claraApi) {
  var _this = this;

  _classCallCheck(this, ClaraAnimation);

  this.activeAnimation = null;

  this.getClips = function () {
    return _this.claraApi.animation.getClips();
  };

  this.playClip = function (clipName, playInReverse) {
    var clip = _this.getClipByName(clipName);
    if (!clip) {
      console.error("Cannot find animation name " + clipName);
      return;
    }
    _this.jumpToStartFrame(clip, playInReverse);
    _this.activeAnimation = clipName;

    _this.claraApi.animation.queueClip(clip.id, {
      autoplay: true,
      playSpeed: playInReverse ? -1 : 1
    });
  };

  this.getClipByName = function (clipName) {
    if (!clipName) {
      return null;
    }
    var clips = _this.claraApi.animation.getClips();
    var selectedClipIndex = clips.findIndex(function (clip) {
      return clip.name === clipName;
    });
    if (selectedClipIndex === -1) {
      console.error("Could not find animation clip with name \"" + clipName + "\"");
      return null;
    }
    return clips[selectedClipIndex];
  };

  this.jumpToStartFrame = function (clip, playInReverse) {
    _this.stopAllAnimation();
    if (_this.activeAnimation && _this.activeAnimation !== clip.name) {
      // Reset previous animation before playing new one
      _this.setClipToStartOrEnd(_this.getClipByName(_this.activeAnimation), false);
    }
    _this.setClipToStartOrEnd(clip, playInReverse);
  };

  this.setClipToStartOrEnd = function (clip, playInReverse) {
    clip.tracks.forEach(function (track) {
      _this.setTrackToStartOrEnd(track, clip, playInReverse);
    });
  };

  this.setTrackToStartOrEnd = function (track, clip, playInReverse) {
    var trackPath = track.path;
    var path = Array.isArray(trackPath) ? trackPath : _this.claraApi.scene.find(trackPath);
    if (!path) {
      return;
    }
    var value = playInReverse ? track.value : track.startValue;
    if (!value) {
      var vs = track.keyframes.vs;
      if (vs) {
        value = vs[playInReverse ? vs.length - 1 : 0];
      } else {
        value = {};
        var keys = Object.keys(track.keyframes);
        keys.forEach(function (key) {
          value[key] = track.keyframes[key].vs[playInReverse ? track.keyframes[key].vs.length - 1 : 0];
        });
      }
    }
    var setFn = clip.set ? clip.set : _this.claraApi.sceneGraph.set;
    setFn(path, value);
  };

  this.resetAllAnimations = function () {
    _this.stopAllAnimation();
    _this.activeAnimation = null;
    var clips = _this.claraApi.animation.getClips();
    clips.forEach(function (clip) {
      _this.setClipToStartOrEnd(clip, false);
    });
  };

  this.stopAllAnimation = function () {
    if (_this.activeAnimation) {
      _this.claraApi.animation.removeAnimation(_this.activeAnimation);
    }
    _this.claraApi.animation.stopPlaying();
  };

  this.claraApi = claraApi;
};

exports.default = ClaraAnimation;

/***/ }),
/* 5 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _instance = __webpack_require__(6);

var _instance2 = _interopRequireDefault(_instance);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var ClaraEvents = function ClaraEvents(claraApi, sceneContainerId) {
  var _this = this;

  _classCallCheck(this, ClaraEvents);

  this.events = {
    ON_FIRST_CLARA_SCENE_INTERACTION: 'ON_FIRST_CLARA_SCENE_INTERACTION',
    ON_HOME_BUTTON_PRESSED: 'ON_HOME_BUTTON_PRESSED'
  };

  this.registerOnLoading = function (onLoading) {
    _this.claraApi.on('loading', onLoading);
  };

  this.registerOnPreloaded = function (onPreLoaded) {
    _this.claraApi.on('preloaded', onPreLoaded);
  };

  this.registerOnRendered = function (onRendered) {
    _this.claraApi.on('rendered', onRendered);
  };

  this.registerOnFirstInteraction = function (onFirstInteraction) {
    _instance2.default.on(_this.events.ON_FIRST_CLARA_SCENE_INTERACTION, onFirstInteraction);
  };

  this.registerOnHomeButtonPressed = function (onHomeButtonPressed) {
    _instance2.default.on(_this.events.ON_HOME_BUTTON_PRESSED, onHomeButtonPressed);
  };

  this.claraApi = claraApi;
  this.sceneContainerId = sceneContainerId;
  this.registerOnRendered(function () {

    var firstInteractionHandler = function firstInteractionHandler() {
      return _instance2.default.emit(_this.events.ON_FIRST_CLARA_SCENE_INTERACTION);
    };
    var sceneContainer = document.getElementById(_this.sceneContainerId);

    sceneContainer.addEventListener('mousedown', firstInteractionHandler, { once: true });
    sceneContainer.addEventListener('touchstart', firstInteractionHandler, { once: true });

    var homeButton = document.querySelector('svg[title="Home"]');
    if (homeButton) {
      homeButton.addEventListener('click', function () {
        _instance2.default.emit(_this.events.ON_HOME_BUTTON_PRESSED);
      });
    }
  });
};

exports.default = ClaraEvents;

/***/ }),
/* 6 */
/***/ (function(module, exports, __webpack_require__) {

var E = __webpack_require__(7);
module.exports = new E();


/***/ }),
/* 7 */
/***/ (function(module, exports) {

function E () {
  // Keep this empty so it's easier to inherit from
  // (via https://github.com/lipsmack from https://github.com/scottcorgan/tiny-emitter/issues/3)
}

E.prototype = {
  on: function (name, callback, ctx) {
    var e = this.e || (this.e = {});

    (e[name] || (e[name] = [])).push({
      fn: callback,
      ctx: ctx
    });

    return this;
  },

  once: function (name, callback, ctx) {
    var self = this;
    function listener () {
      self.off(name, listener);
      callback.apply(ctx, arguments);
    };

    listener._ = callback
    return this.on(name, listener, ctx);
  },

  emit: function (name) {
    var data = [].slice.call(arguments, 1);
    var evtArr = ((this.e || (this.e = {}))[name] || []).slice();
    var i = 0;
    var len = evtArr.length;

    for (i; i < len; i++) {
      evtArr[i].fn.apply(evtArr[i].ctx, data);
    }

    return this;
  },

  off: function (name, callback) {
    var e = this.e || (this.e = {});
    var evts = e[name];
    var liveEvents = [];

    if (evts && callback) {
      for (var i = 0, len = evts.length; i < len; i++) {
        if (evts[i].fn !== callback && evts[i].fn._ !== callback)
          liveEvents.push(evts[i]);
      }
    }

    // Remove event from queue to prevent memory leak
    // Suggested by https://github.com/lazd
    // Ref: https://github.com/scottcorgan/tiny-emitter/commit/c6ebfaa9bc973b33d110a84a307742b7cf94c953#commitcomment-5024910

    (liveEvents.length)
      ? e[name] = liveEvents
      : delete e[name];

    return this;
  }
};

module.exports = E;


/***/ }),
/* 8 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var ColorHelper = function ColorHelper() {
  _classCallCheck(this, ColorHelper);
};

ColorHelper.createColorObject0to1 = function (r, g, b) {
  return {
    r: r / 255,
    g: g / 255,
    b: b / 255
  };
};

ColorHelper.convertColorGammaToLinear = function (color) {
  color["r"] = Math.pow(color["r"], 2.2);
  color["g"] = Math.pow(color["g"], 2.2);
  color["b"] = Math.pow(color["b"], 2.2);

  return color;
};

exports.default = ColorHelper;

/***/ }),
/* 9 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var ClaraSnapshot = function ClaraSnapshot(claraApi) {
  var _this = this;

  _classCallCheck(this, ClaraSnapshot);

  this.claraApi = null;

  this.downloadFile = function () {
    return _this.runSnapshot();
  };

  this.getDataUrlImage = function () {
    return _this.runSnapshot('dataURL');
  };

  this.getBlobImage = function () {
    return _this.runSnapshot('blob');
  };

  this.runSnapshot = function () {
    var dataType = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'image';

    _this.claraApi.commands.setCommandOptions('snapshot', { dataType: dataType });
    return _this.claraApi.commands.runCommand('snapshot');
  };

  this.claraApi = claraApi;
};

exports.default = ClaraSnapshot;

/***/ })
/******/ ]);