export default class ClaraSnapshot {
  claraApi = null;

  constructor(claraApi) {
    this.claraApi = claraApi;
  }

  downloadFile = () => this.runSnapshot();

  getDataUrlImage = () => this.runSnapshot('dataURL');

  getBlobImage = () => this.runSnapshot('blob');

  runSnapshot = (dataType = 'image') => {
    this.claraApi.commands.setCommandOptions('snapshot', { dataType });
    return this.claraApi.commands.runCommand('snapshot');
  }
}
